--[[--
	alex/ALA	Please Keep WOW Addon open-source & Reduce barriers for others.
	复用代码请在显著位置标注来源【ALA@网易有爱】
	喜欢加密和乱码的亲，请ALT+F4
--]]--
local ADDON, NS = ...;

local _G = _G;
do
	if NS.__fenv == nil then
		NS.__fenv = setmetatable({  },
				{
					__index = _G,
					__newindex = function(t, key, value)
						rawset(t, key, value);
						print("ain assign global", key, value);
						return value;
					end,
				}
			);
	end
	setfenv(1, NS.__fenv);
end

local tinsert, tremove, gsub, format, strfind, date = tinsert, tremove, gsub, format, strfind, date;

local function _noop_()
	return true;
end
local bak_INSTANCE_RESET_FAILED = INSTANCE_RESET_FAILED;
local instance_reset_failed_pattern = gsub(bak_INSTANCE_RESET_FAILED, "%%s", "(.+)");
local bak_INSTANCE_RESET_SUCCESS = INSTANCE_RESET_SUCCESS;
local instance_reset_success_pattern = gsub(bak_INSTANCE_RESET_SUCCESS, "%%s", "(.+)");
-- RESET_FAILED_NOTIFY
local MINIMAL_INTERVAL = 1;

local func = {  };
local var = {
	prev_area = nil,
	prev_in_instance = nil,
	next_reset_count_in = nil,
	next_reset_out_instance = nil,
};
local instance_timer_sv = nil;
local local_timer = nil;
local char_timer = nil;
local manually_timer = nil;
local global_daily_limit = 30;

local L = {  };
do
	if GetLocale() == 'zhCN' or GetLocale() == 'zhTW' then
		L["INSTANCE_CHANCE"] = "副本次数";
		L["CURRENT"] = "当前";
		L["AVAILABLE"] = "可用";
		L["AVAILABLE_GLOBAL"] = "可重置";
		L["RESET"] = "%s 已被重置";
		L["LOCK"] = "锁定";
		L["CLOSE"] = "关闭";
		L["TICK"] = "手动添加CD于当前时间";
		L["RESETINSTANCE"] = "重置副本";
		L["RECORDLOCK"] = "手动记录进度";
		L["REVOKE"] = "撤销手动记录";
		L["BAR_ON"] = "显示按钮";
		L["BAR_OFF"] = "隐藏按钮";
		L["BAR_ON_TOP"] = "按钮在上方";
		L["BAR_ON_BOTTOM"] = "按钮在下方";
		L["BAR_ON_LEFT"] = "按钮居左";
		L["BAR_ON_RIGHT"] = "按钮居右";
		L["BAR_ON_CENTER"] = "按钮居中";
		L["TIP_GLOBAL_HEADER"] = "\124cffffffff24小时副本次数\124r";
		L["TIP_INSTANCE"] = "\124cffffffff副本";
		L["TIP_GLOBAL_FORMAT_AVAILABLE"] = "\124cff00ff00可用: %d\124r";
		L["TIP_GLOBAL_FORMAT_LOCKED"] = "\124cffff0000锁定: %d\124r";
		L["TIP_GLOBAL_SHIFT"] = "按Shift显示详情";
	else
		L["INSTANCE_CHANCE"] = "Inst lock ";
		L["CURRENT"] = "CUR";
		L["AVAILABLE"] = "AVL";
		L["AVAILABLE_GLOBAL"] = "AVL";
		L["RESET"] = "%s reseted.";
		L["LOCK"] = "LOCK";
		L["CLOSE"] = "CLOSE";
		L["TICK"] = "Manual Add";
		L["RESETINSTANCE"] = "Reset instance";
		L["RECORDLOCK"] = "Manually record";
		L["REVOKE"] = "Revoke record";
		L["BAR_ON"] = "Show buttons";
		L["BAR_OFF"] = "Hide buttons";
		L["BAR_ON_TOP"] = "Butons on top";
		L["BAR_ON_BOTTOM"] = "Buttons on bottom";
		L["BAR_ON_LEFT"] = "Buttons on left";
		L["BAR_ON_RIGHT"] = "Buttons on right";
		L["BAR_ON_CENTER"] = "Buttons on center";
		L["TIP_GLOBAL_HEADER"] = "\124cffffffffInst limit in 24hrs\124r";
		L["TIP_INSTANCE"] = "\124cffffffffInst ";
		L["TIP_GLOBAL_FORMAT_AVAILABLE"] = "\124cff00ff00AVL: %d\124r";
		L["TIP_GLOBAL_FORMAT_LOCKED"] = "\124cffff0000LOCKED: %d\124r";
		L["TIP_GLOBAL_SHIFT"] = "Holding Shift to show details";
	end
end

local function Info_OnEnter(self)
	GameTooltip:SetOwner(self, "ANCHOR_TOP");
	GameTooltip:SetText(self.info);
	GameTooltip:Show();
end
local function Info_OnLeave(self)
	if GameTooltip:IsOwned(self) then
		GameTooltip:Hide();
	end
end

local board = CreateFrame("FRAME", nil, UIParent);

function NS.initUI()
	-->	create
		NS.instance_timer_board = board;
		board:SetSize(140, 80);
		board:SetBackdrop({
			bgFile = "Interface/ChatFrame/ChatFrameBackground",
			edgeFile = "Interface/ChatFrame/ChatFrameBackground",
			tile = true,
			edgeSize = 1,
			tileSize = 5,
		});
		board:SetPoint("TOP", 0, -24);
		board:Show();
		board:SetMovable(true);
		-- board:EnableMouse(true);
		-- board:RegisterForDrag("LeftButton");
		local lines = {  };
		board.lines = lines;
		for i = 1, 5 do
			local left = board:CreateFontString(nil, "OVERLAY", "GameFontNormal");
			-- left:SetFont(GameFontNormal:GetFont(), 16);
			left:SetPoint("TOPLEFT", board, "TOPLEFT", 0, - 16 * (i - 1));
			left:SetJustifyH("CENTER");
			left:Show();
			left:SetText("\124cffffff00" .. L["INSTANCE_CHANCE"] .. i .. "\124r:  ");
			local line = board:CreateFontString(nil, "OVERLAY", "GameFontNormal");
			-- line:SetFont(GameFontNormal:GetFont(), 16);
			line:SetPoint("TOP", left, "TOP", 0, 0);
			line:SetPoint("RIGHT", board, "RIGHT", 0, 0);
			line:SetJustifyH("CENTER");
			line:Show();
			line:SetText("\124cff00ff00" .. L["AVAILABLE"] .. "\124r");
			line.id = i;
			lines[i] = line;
		end

		local bar = CreateFrame("FRAME", nil, board);
		bar:SetSize(52, 16);
		-- bar:SetBackdrop({
		-- 	bgFile = "Interface/ChatFrame/ChatFrameBackground",
		-- 	edgeFile = "Interface/ChatFrame/ChatFrameBackground",
		-- 	tile = true,
		-- 	edgeSize = 1,
		-- 	tileSize = 5,
		-- });
		bar:Show();
		bar:EnableMouse(true);
		bar:SetMovable(false);
		board.bar = bar;

		--	manually record lock
		local btn1 = CreateFrame("BUTTON", nil, bar);
		btn1:SetSize(16, 16);
		btn1:SetNormalTexture("interface\\common\\indicator-red");
		btn1:SetHighlightTexture("Interface\\common\\indicator-gray");
		btn1:SetPoint("LEFT", bar, "LEFT", 0, 0);
		btn1:Show();
		btn1:EnableMouse(true);
		-- btn1:RegisterForClicks("LeftButton");
		btn1.info = L["RECORDLOCK"];
		btn1:SetScript("OnEnter", Info_OnEnter);
		btn1:SetScript("OnLeave", Info_OnLeave);
		board.btn1 = btn1;

		--	revoke
		local btn2 = CreateFrame("BUTTON", nil, bar);
		btn2:SetSize(16, 16);
		btn2:SetNormalTexture("interface\\common\\indicator-yellow");
		btn2:SetDisabledTexture("Interface\\common\\indicator-gray");
		btn2:SetHighlightTexture("Interface\\common\\indicator-gray");
		btn2:SetPoint("LEFT", btn1, "RIGHT", 2, 0);
		btn2:Show();
		btn2:EnableMouse(true);
		-- btn2:RegisterForClicks("LeftButton");
		btn2.info = L["REVOKE"];
		btn2:SetScript("OnEnter", Info_OnEnter);
		btn2:SetScript("OnLeave", Info_OnLeave);
		btn2:Disable();
		board.btn2 = btn2;

		--	reset instance
		local btn3 = CreateFrame("BUTTON", nil, bar);
		btn3:SetSize(16, 16);
		btn3:SetNormalTexture("interface\\common\\indicator-green");
		btn3:SetHighlightTexture("Interface\\common\\indicator-gray");
		btn3:SetPoint("LEFT", btn2, "RIGHT", 2, 0);
		btn3:Show();
		btn3:EnableMouse(true);
		-- btn3:RegisterForClicks("LeftButton");
		btn3.info = L["RESETINSTANCE"];
		btn3:SetScript("OnEnter", Info_OnEnter);
		btn3:SetScript("OnLeave", Info_OnLeave);
		board.btn3 = btn3;
	--
	-->	handler
		btn1:SetScript("OnClick", function()
			local t = func.tick();
			if t then
				tinsert(manually_timer, t);
				btn2:Enable();
			end
		end);
		btn2:SetScript("OnClick", function()
			if #manually_timer > 0 then
				while manually_timer[1] do
					local t = tremove(manually_timer);
					for i = #local_timer, 1, -1 do
						if local_timer[i] == t then
							tremove(local_timer, i);
							for j = #char_timer, 1, -1 do
								if char_timer[j] == t then
									tremove(char_timer, j);
									break;
								end
							end
							t = true;
							break;
						end
					end
					if t == true then
						break;
					end
				end
			end
			func.update_table();
			if #manually_timer == 0 then
				btn2:Disable();
			end
		end);
		btn3:SetScript("OnClick", function()
			ResetInstances();
		end);
		function func.lock()
			board:EnableMouse(false);
			board:SetBackdropColor(0.0, 0.0, 0.0, 0.0);
			board:SetBackdropBorderColor(0.0, 0.0, 0.0, 0.0);
			instance_timer_sv.locked = true;
		end
		function func.unlock()
			board:EnableMouse(true);
			board:SetBackdropColor(0.0, 0.0, 0.0, 0.5);
			board:SetBackdropBorderColor(0.0, 0.0, 0.0, 0.5);
			instance_timer_sv.locked = false;
		end
		function func.on()
			board:Show();
			bar:Show();
			instance_timer_sv.on = true;
		end
		function func.off()
			board:Hide();
			bar:Hide();
			instance_timer_sv.on = false;
		end
		function func.bar_on()
			bar:Show();
			instance_timer_sv.bar_enabled = true;
		end
		function func.bar_off()
			bar:Hide();
			instance_timer_sv.bar_enabled = false;
		end
		function func.bar_on_t()
			bar:ClearAllPoints();
			if instance_timer_sv.bar_pos_v == "CENTER" then
				bar:SetPoint("BOTTOM", board, "TOP", 0, 1);
			else
				bar:SetPoint("BOTTOM" .. instance_timer_sv.bar_pos_v, board, "TOP" .. instance_timer_sv.bar_pos_v, 0, 1);
			end
			instance_timer_sv.bar_pos = "TOP";
		end
		function func.bar_on_b()
			bar:ClearAllPoints();
			if instance_timer_sv.bar_pos_v == "CENTER" then
				bar:SetPoint("TOP", board, "BOTTOM", 0, -1);
			else
				bar:SetPoint("TOP" .. instance_timer_sv.bar_pos_v, board, "BOTTOM" .. instance_timer_sv.bar_pos_v, 0, -1);
			end
			instance_timer_sv.bar_pos = "BOTTOM";
		end
		function func.bar_on_l()
			bar:ClearAllPoints();
			if instance_timer_sv.bar_pos == "TOP" then
				bar:SetPoint("BOTTOMLEFT", board, "TOPLEFT", 0, 1);
			else
				bar:SetPoint("TOPLEFT", board, "BOTTOMLEFT", 0, -1);
			end
			instance_timer_sv.bar_pos_v = "LEFT";
		end
		function func.bar_on_r()
			bar:ClearAllPoints();
			if instance_timer_sv.bar_pos == "TOP" then
				bar:SetPoint("BOTTOMRIGHT", board, "TOPRIGHT", 0, 1);
			else
				bar:SetPoint("TOPRIGHT", board, "BOTTOMRIGHT", 0, -1);
			end
			instance_timer_sv.bar_pos_v = "RIGHT";
		end
		function func.bar_on_c()
			bar:ClearAllPoints();
			if instance_timer_sv.bar_pos == "TOP" then
				bar:SetPoint("BOTTOM", board, "TOP", 0, 1);
			else
				bar:SetPoint("TOP", board, "BOTTOM", 0, -1);
			end
			instance_timer_sv.bar_pos_v = "CENTER";
		end
		local drop_menu_table = {
			handler = _noop_,
			elements = {
				{
					handler = func.lock,
					para = {  },
					text = L["LOCK"],
				},
				{
					handler = func.off,
					para = {  },
					text = L["CLOSE"],
				},
			},
		};
		local drop_menu_table_bar_on = {
			handler = func.bar_on,
			para = {  },
			text = L["BAR_ON"],
		};
		local drop_menu_table_bar_off = {
			handler = func.bar_off,
			para = {  },
			text = L["BAR_OFF"],
		};
		local drop_menu_table_bar_t = {
			handler = func.bar_on_t,
			para = {  },
			text = L["BAR_ON_TOP"];
		};
		local drop_menu_table_bar_b = {
			handler = func.bar_on_b,
			para = {  },
			text = L["BAR_ON_BOTTOM"];
		};
		local drop_menu_table_bar_l = {
			handler = func.bar_on_l,
			para = {  },
			text = L["BAR_ON_LEFT"];
		};
		local drop_menu_table_bar_r = {
			handler = func.bar_on_r,
			para = {  },
			text = L["BAR_ON_RIGHT"];
		};
		local drop_menu_table_bar_c = {
			handler = func.bar_on_c,
			para = {  },
			text = L["BAR_ON_CENTER"];
		};

		board:SetScript("OnMouseDown", function(self, button)
			if button == "LeftButton" then
				self:StartMoving();
			else
				if instance_timer_sv.bar_enabled then
					drop_menu_table.elements[3] = drop_menu_table_bar_off;
				else
					drop_menu_table.elements[3] = drop_menu_table_bar_on;
				end
				if instance_timer_sv.bar_pos == "TOP" then
					drop_menu_table.elements[4] = drop_menu_table_bar_b;
				else
					drop_menu_table.elements[4] = drop_menu_table_bar_t;
				end
				if instance_timer_sv.bar_pos_v == "LEFT" then
					drop_menu_table.elements[5] = drop_menu_table_bar_c;
					drop_menu_table.elements[6] = drop_menu_table_bar_r;
				elseif instance_timer_sv.bar_pos_v == "RIGHT" then
					drop_menu_table.elements[5] = drop_menu_table_bar_l;
					drop_menu_table.elements[6] = drop_menu_table_bar_c;
				else
					drop_menu_table.elements[5] = drop_menu_table_bar_l;
					drop_menu_table.elements[6] = drop_menu_table_bar_r;
				end
				ALADROP(board, "BOTTOMLEFT", drop_menu_table);
			end
		end);
		board:SetScript("OnMouseUp", function(self, button)
			self:StopMovingOrSizing();
			instance_timer_sv.pos = { self:GetPoint(), };
			for i, v in ipairs(instance_timer_sv.pos) do
				if type(v) == 'table' then
					instance_timer_sv.pos[i] = v:GetName();
				end
			end
		end);
	--
	-->	new for hotfix 20200612
		local timer32 = CreateFrame("BUTTON", nil, board);
		timer32:SetHeight(24);
		timer32:SetPoint("TOPLEFT", board, "BOTTOMLEFT");
		timer32:SetPoint("TOPRIGHT", board, "BOTTOMRIGHT");
		timer32:Show();
		board.timer32 = timer32;
		local timer32str = timer32:CreateFontString(nil, "OVERLAY", "GameFontNormal");
		-- timer32str:SetFont(GameFontNormal:GetFont(), 16);
		timer32str:SetPoint("CENTER");
		timer32str:SetJustifyH("CENTER");
		timer32str:Show();
		board.timer32str = timer32str;
		local function timer32OnEnter(self)
			local TIME = GetServerTime();
			if self:GetTop() + self:GetBottom() < UIParent:GetHeight() then
				GameTooltip:SetOwner(self, "ANCHOR_TOP", 0, 96);
			else
				GameTooltip:SetOwner(self, "ANCHOR_BOTTOM");
			end
			GameTooltip:SetText(L["TIP_GLOBAL_HEADER"]);
			GameTooltip:AddDoubleLine(format(L["TIP_GLOBAL_FORMAT_AVAILABLE"], global_daily_limit - 1 - #char_timer),
										format(L["TIP_GLOBAL_FORMAT_LOCKED"], #char_timer));
			local shiftdown = IsShiftKeyDown();
			self.shiftdown = shiftdown;
			if shiftdown then
				for i = 1, #char_timer do
					GameTooltip:AddDoubleLine(L["TIP_INSTANCE"] .. i, func.time_to_stamp("\124cffff0000[%H:%M:%S]\124r", char_timer[i] - TIME + 86400));	--	actually 86400 is unnecessary. for good reading
				end
			else
				GameTooltip:AddLine(L["TIP_GLOBAL_SHIFT"]);
			end
			GameTooltip:Show();
		end
		timer32:SetScript("OnEnter", timer32OnEnter);
		timer32:SetScript("OnLeave", Info_OnLeave);
		timer32:SetScript("OnEvent", function(self)
			if GameTooltip:IsOwned(self) then
				-- GameTooltip:Hide();
				timer32OnEnter(self);
			end
		end);
		timer32:RegisterEvent("MODIFIER_STATE_CHANGED");
	--
	return board;
end

function func.time_to_stamp(f, t)
	return date(f, t + 57600 - 1);
end
function func.tick()
	if #local_timer < 5 then
		local t = GetServerTime();
		if #local_timer == 0 or t > local_timer[#local_timer] + MINIMAL_INTERVAL then
			tinsert(local_timer, t);
			tinsert(char_timer, t);
			func.update_table();
			return t;
		end
	end
end
function func.update_table()
	local TIME = GetServerTime();
	for i = #local_timer, 1, -1 do
		if local_timer[i] + 3600 < TIME then
			tremove(local_timer, i);
		end
	end
	for i = #manually_timer, 1, -1 do
		if manually_timer[i] + 3600 < TIME then
			tremove(manually_timer, i);
		end
	end
	if not manually_timer[1] then
		board.btn2:Disable();
	end
	for i = #char_timer, 1, -1 do
		if char_timer[i] + 86400 < TIME then
			tremove(char_timer, i);
		end
	end
	local current = true;
	local lines = board.lines;
	for i = 1, 5 do
		if local_timer[i] then
			lines[i]:SetText(func.time_to_stamp("\124cffff0000[%M:%S]\124r", local_timer[i] - TIME + 3600));
		else
			if current then
				current = false;
				lines[i]:SetText("\124cffffff00" .. L["CURRENT"] .. "\124r");
			else
				lines[i]:SetText("\124cff00ff00" .. L["AVAILABLE"] .. "\124r");
			end
		end
	end
	board.timer32str:SetText("\124cff00ff00" .. L["AVAILABLE_GLOBAL"] .. (global_daily_limit - 1 - #char_timer) .. "\124r - \124cffff0000" .. L["LOCK"] .. #char_timer .. "\124r");
end

function func.CHAT_MSG_SYSTEM(msg)
	if bak_INSTANCE_RESET_SUCCESS ~= INSTANCE_RESET_SUCCESS then
		bak_INSTANCE_RESET_SUCCESS = INSTANCE_RESET_SUCCESS;
		instance_reset_success_pattern = gsub(bak_INSTANCE_RESET_SUCCESS, "%%s", "(.+)");
	end
	local _, instance;
	_, _, instance = strfind(msg, instance_reset_success_pattern);
	if instance then
		if UnitPlayerOrPetInRaid('player') then
			SendChatMessage(msg, 'RAID');
		elseif UnitPlayerOrPetInParty('player') then
			SendChatMessage(msg, 'PARTY');
		end
	else
		if bak_INSTANCE_RESET_FAILED ~= INSTANCE_RESET_FAILED then
			bak_INSTANCE_RESET_FAILED = INSTANCE_RESET_FAILED;
			instance_reset_failed_pattern = gsub(bak_INSTANCE_RESET_FAILED, "%%s", "(.+)");
		end
		_, _, instance = strfind(msg, instance_reset_failed_pattern);
		if instance then
			if UnitPlayerOrPetInRaid('player') then
				SendChatMessage(format(L["RESET"], instance), 'RAID');
			elseif UnitPlayerOrPetInParty('player') then
				SendChatMessage(format(L["RESET"], instance), 'PARTY');
			end
		end
	end
	if instance then
		func.tick();
	elseif  msg == RESET_FAILED_NOTIFY then
		var.next_reset_out_instance = true;
	end
end

function func.ZONE_CHANGED_NEW_AREA()
	local is_in_instance, instance_type = IsInInstance();
	-- if var.prev_in_instance and not is_in_instance then
	--	 var.next_reset_count_in = true;
	-- else
	--	 var.next_reset_count_in = false;
	-- end
	if is_in_instance and (instance_type == 'party' or instance_type == 'raid') then
	--	 var.prev_in_instance = true;
	-- else
	--	 var.prev_in_instance = false;
		if var.next_reset_out_instance then
			var.next_reset_out_instance = nil;
			func.tick();
		end
	end
	-- print(GetZoneText(), GetRealZoneText());
	-- print(var.prev_in_instance, is_in_instance, var.next_reset_count_in)
end

function func.init()
	-- board:UnregisterEvent("PLAYER_ENTERING_WORLD");
	func.PLAYER_ENTERING_WORLD = func.ZONE_CHANGED_NEW_AREA;
	func.PLAYER_ENTERING_WORLD();
	instance_timer_sv = InstLockSV;
	char_timer = instance_timer_sv.char_timer[NS.pGUID];
	local_timer = instance_timer_sv.realm_timer[NS.realmID].local_timer;
	manually_timer = instance_timer_sv.realm_timer[NS.realmID].manually_timer;
	NS.initUI();
	if #manually_timer == 0 then
		board.btn2:Disable();
	else
		board.btn2:Enable();
	end
	if instance_timer_sv.locked then
		func.lock();
	else
		func.unlock();
	end
	if instance_timer_sv.on then
		func.on();
	else
		func.off();
	end
	if instance_timer_sv.pos then
		board:ClearAllPoints();
		board:SetPoint(instance_timer_sv.pos[1], instance_timer_sv.pos[2], instance_timer_sv.pos[3], instance_timer_sv.pos[4], instance_timer_sv.pos[5]);
	end
	instance_timer_sv.bar_pos = instance_timer_sv.bar_pos or "TOP";
	instance_timer_sv.bar_pos_v = instance_timer_sv.bar_pos_v or "RIGHT";
	if instance_timer_sv.bar_pos == "TOP" then
		func.bar_on_t();
	else
		func.bar_on_b();
	end
	instance_timer_sv.bar_enabled = (instance_timer_sv.bar_enabled == nil) and true or instance_timer_sv.bar_enabled;
	if instance_timer_sv.bar_enabled then
		func.bar_on();
	else
		func.bar_off();
	end
	-- hooksecurefunc("ResetInstances", function()
	--	 if var.next_reset_count_in then
	--		 var.next_reset_count_in = false;
	--		 tinsert(local_timer, GetServerTime() + 3600);
	--	 end
	-- end);
	C_Timer.NewTicker(1.0, func.update_table);
	C_Timer.After(0.1, function()
		bak_INSTANCE_RESET_FAILED = INSTANCE_RESET_FAILED;
		instance_reset_failed_pattern = gsub(bak_INSTANCE_RESET_FAILED, "%%s", "(.+)");
		bak_INSTANCE_RESET_SUCCESS = INSTANCE_RESET_SUCCESS;
		instance_reset_success_pattern = gsub(bak_INSTANCE_RESET_SUCCESS, "%%s", "(.+)");
	end);
end
func.PLAYER_ENTERING_WORLD = func.init;

board:RegisterEvent("PLAYER_ENTERING_WORLD");
-- board:RegisterEvent("ZONE_CHANGED_NEW_AREA");
board:RegisterEvent("CHAT_MSG_SYSTEM");
function func.OnEvent(self, event, ...)
	func[event](...);
end
board:SetScript("OnEvent", func.OnEvent);

_G.SLASH_ALAINSTANCETIMER1 = "/alainstancetimer";
_G.SLASH_ALAINSTANCETIMER2 = "/alainsttimer";
_G.SLASH_ALAINSTANCETIMER3 = "/alainst";
_G.SLASH_ALAINSTANCETIMER4 = "/ait";
_G.SLASH_ALAINSTANCETIMER5 = "/instancelockeddowntimer";
_G.SLASH_ALAINSTANCETIMER6 = "/ilt";
SlashCmdList["ALAINSTANCETIMER"] = function(msg)
	if strfind(msg, "^lock") then
		func.lock();
	elseif strfind(msg, "^unlock") then
		func.unlock();
	elseif strfind(msg, "^on") then
		func.on();
	elseif strfind(msg, "^off") then
		func.off();
	elseif strfind(msg, "^baron") then
		func.bar_on();
	elseif strfind(msg, "^baroff") then
		func.bar_off();
	elseif strfind(msg, "^TOP") then
		func.bar_on_t();
	elseif strfind(msg, "^BOTTOM") then
		func.bar_on_b();
	elseif strfind(msg, "^LEFT") then
		func.bar_on_l();
	elseif strfind(msg, "^RIGHT") then
		func.bar_on_r();
	elseif strfind(msg, "^CENTER") then
		func.bar_on_c();
	elseif strfind(msg, "^toggle_lock") then
		if instance_timer_sv.locked then
			func.unlock();
		else
			func.lock();
		end
	elseif strfind(msg, "^reset_pos") then
		instance_timer_sv.pos = nil;
		board:ClearAllPoints();
		board:SetPoint("TOP", 0, -24);
	end
end

